package com.tarena.worm;

import java.util.Arrays;

/**
 * ̰
 * 
 */
public class Worm {
	public static final int DEFAULT_LENGTH = 12;
	private Cell[] cells;

	public static final int UP = 1;
	public static final int DOWN = -1;
	public static final int LEFT = 2;
	public static final int RIGHT = -2;

	/** ߵǰз */
	private int currentDirection;

	public Worm() {
		cells = new Cell[DEFAULT_LENGTH];
		for (int i = 0; i < cells.length; i++) {
			cells[i] = new Cell(i, 0);// [0,0] [1,0] [2,0]
		}
		currentDirection = DOWN;
		// cells = new Cell[]{new Cell(0,0),new Cell(1,0),...};
	}

	public boolean contains(int x, int y) {
		for (int i = 0; i < cells.length; i++) {
			Cell node = cells[i];
			if (node.getX() == x && node.getY() == y) {
				return true;
			}
		}
		return false;
	}

	/**
	 * 1) currentDirectiondirectionĺ, 0ʾ, ͽ, κζ
	 * 2)currentDirection = direction ı䵱ǰķ, Ϊ´еķ 3) жϵǰͷڵʳһ
	 * һ˵ǳԵʳ 4) Եʳ, ͽcells cellsݵÿԪƶ. 5)
	 * ͷڵͷλcells[0]=newHead 6) ǷԵʳ
	 */
	public boolean creep(int direction, Cell food) {
		if (currentDirection + direction == 0) {
			return false; // ,κζ
		}
		currentDirection = direction;
		Cell head = createHead(direction);
		boolean eat = head.getX() == food.getX() && head.getY() == food.getY();
		// boolean eat = false;
		// if(head.getX()==food.getX() &&
		// head.getY()==food.getY()){
		// eat = true;
		// }
		if (eat) {
			cells = Arrays.copyOf(cells, cells.length + 1);
		}
		for (int i = cells.length - 1; i >= 1; i--) {
			cells[i] = cells[i - 1];
		}
		cells[0] = head;
		return eat;
	}

	public boolean hit() {
		return hit(currentDirection);
	}

	public boolean hit(int direction) {
		// 򲻴ײ
		if (currentDirection + direction == 0) {
			return false;
		}
		// System.out.println("(2)"+direction);
		Cell head = createHead(direction);
		// System.out.println(head);
		if (head.getX() < 0 || head.getX() >= WormStage.COLS || head.getY() < 0
				|| head.getY() >= WormStage.ROWS) {
			return true;
		}
		for (int i = 0; i < cells.length - 1; i++) {
			Cell node = cells[i];
			if (node.getX() == head.getX() && node.getY() == head.getY()) {
				return true;
			}
		}
		return false;
	}

	public boolean creep(Cell food) {
		return creep(currentDirection, food);
	}

	public void creep() {
		for (int i = cells.length - 1; i >= 1; i--) {
			cells[i] = cells[i - 1];
		}
		cells[0] = createHead(currentDirection);
	}

	private Cell createHead(int direction) {
		int x = cells[0].getX();
		int y = cells[0].getY();
		switch (direction) {
		case DOWN:
			y++;
			break;
		case UP:
			y--;
			break;
		case LEFT:
			x--;
			break;
		case RIGHT:
			x++;
			break;
		}
		return new Cell(x, y);
	}

	/** Worm.java */
	public Cell[] getCells() {
		return Arrays.copyOf(cells, cells.length);
	}

	public String toString() {
		return Arrays.toString(cells);
	}

}
