package com.tarena.worm;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class WormStage extends JPanel {
	/**  */
	public static final int ROWS = 35;
	/**  */
	public static final int COLS = 35;
	/** ӴС 10 */
	public static final int CELL_SIZE = 10;

	public static Image background;
	public static Image foodImage;
	public static Image cellImage;
	
	private Worm worm;
	private Cell food;

	public WormStage() {
		//¼ͼƬķ֪ɣͼƬWormStage.java
		//ͬһУ
		background = Toolkit.getDefaultToolkit().
				createImage(getClass().getResource("bg.png"));
		foodImage = Toolkit.getDefaultToolkit().
				createImage(getClass().getResource("food.png"));
		cellImage = Toolkit.getDefaultToolkit().
				createImage(getClass().getResource("cell.png"));
		worm = new Worm();
		food = createFood();
	}

	/**
	 * һʳ 1 xy 2 Ƿxy 2.1   1 3 ʳڵ㡣
	 * */
	private Cell createFood() {
		int x;
		int y;
		Random r = new Random();
		do {
			x = r.nextInt(COLS);
			y = r.nextInt(ROWS);
		} while (worm.contains(x, y));
		return new Cell(x, y);
	}

	public String toString() {
		return "worm:" + worm + "\nfood:" + food;
	}

	/** дͼ */
	public void paint(Graphics g) {
		// 䱳ɫ
		g.drawImage(background, 0, 0, null);
		// ʳ
		g.translate(54, 49);
		g.drawImage(foodImage, 
				CELL_SIZE * food.getX(), CELL_SIZE * food.getY(), null);
		// 
		Cell[] cells = worm.getCells();
		for (int i = 0; i < cells.length; i++) {
			Cell node = cells[i];
			g.drawImage(cellImage, 
					CELL_SIZE * node.getX(), CELL_SIZE * node.getY(), null);

		}
	}

	/**  */

	public static void main(String[] args) {
		//  WormStage.java
		JFrame frame = new JFrame("̰");
		WormStage pane = new WormStage();// 
		frame.add(pane);// 
		frame.setSize(470, 480);// ôڵĴС
		frame.setLocationRelativeTo(null);// frame
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pane.action();// ߵ
	}

	private void action() {
		// worm.creep(food);
		// repaint();//swing JPanel ķᾡ
		// ػ湦ܣpaint(g) ƽ
		Timer timer = new Timer();
		timer.schedule(new TimerTask() {
			public void run() {
				// п߼
				if (worm.hit()) {
					worm = new Worm();
					food = createFood();
				} else {
					boolean eat = worm.creep(food);
					if (eat) {
						food = createFood();
					}
				}
				repaint();
			}
		}, 0, 1000 / 7);
		// this ǵǰ̨
		this.requestFocus();
		this.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				// key ĸ£
				int key = e.getKeyCode();
				switch (key) {
				case KeyEvent.VK_UP:// ϼͷ£
					creepTo(Worm.UP);
					break;
				case KeyEvent.VK_DOWN:// ¼ͷ£
					creepTo(Worm.DOWN);
					break;
				case KeyEvent.VK_LEFT:// ͷ£
					creepTo(Worm.LEFT);
					break;
				case KeyEvent.VK_RIGHT:// Ҽͷ£
					creepTo(Worm.RIGHT);
					break;
				}
			}
		});// addKeyListener
	}// action()

	/** пƷڰʱ */
	private void creepTo(int direction) {
		if (worm.hit(direction)) {
			worm = new Worm();
			food = createFood();
		} else {
			boolean eat = worm.creep(direction, food);
			if (eat) {
				food = createFood();
			}
		}
		repaint();
	}
}// WormStage

